Index: /inundation/ga/storm_surge/pyvolution/documentation/mesh.fig
===================================================================
--- /inundation/ga/storm_surge/pyvolution/documentation/mesh.fig	(revision 626)
+++ /inundation/ga/storm_surge/pyvolution/documentation/mesh.fig	(revision 626)
@@ -0,0 +1,130 @@
+#FIG 3.2
+Landscape
+Center
+Metric
+A4      
+100.00
+Single
+-2
+1200 2
+6 450 450 1800 4050
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 450 1350 1350 1350 1350 4050 450 4050 450 1350
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 900 1350 900 4050
+4 0 0 50 -1 18 12 0.0000 4 135 1080 450 675 class Points\001
+4 0 0 50 -1 0 12 0.0000 4 180 1350 450 1125 coordinates (x, y)\001
+-6
+6 3915 5400 5265 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5265 5400 5265 8100
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 3915 5400 4815 5400 4815 8100 3915 8100 3915 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4365 5400 4365 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4815 5400 5265 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4815 8100 5265 8100
+-6
+6 5940 5400 7290 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 7290 5400 7290 8100
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 5940 5400 6840 5400 6840 8100 5940 8100 5940 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6390 5400 6390 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6840 5400 7290 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6840 8100 7290 8100
+-6
+6 7965 5400 9315 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 9315 5400 9315 8100
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 7965 5400 8865 5400 8865 8100 7965 8100 7965 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 8415 5400 8415 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 8865 5400 9315 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 8865 8100 9315 8100
+-6
+6 2295 5040 3015 8100
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 2295 5400 2745 5400 2745 8100 2295 8100 2295 5400
+4 0 0 50 -1 0 12 0.0000 4 135 705 2295 5175 centroids\001
+-6
+6 6255 8640 7965 11700
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 6255 9000 6705 9000 6705 11700 6255 11700 6255 9000
+4 0 0 50 -1 0 12 0.0000 4 180 1710 6255 8775 number_of_boundaries\001
+-6
+6 495 8685 945 11700
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 495 9000 945 9000 945 11700 495 11700 495 9000
+4 0 0 50 -1 0 12 0.0000 4 90 420 495 8775 areas\001
+-6
+6 1620 8685 2070 11700
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 1620 9000 2070 9000 2070 11700 1620 11700 1620 9000
+4 0 0 50 -1 0 12 0.0000 4 135 330 1620 8820 radii\001
+-6
+6 2835 8640 4680 11700
+6 2835 9000 4185 11700
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4185 9000 4185 11700
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 2835 9000 3735 9000 3735 11700 2835 11700 2835 9000
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3285 9000 3285 11700
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3735 9000 4185 9000
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3735 11700 4185 11700
+-6
+4 0 0 50 -1 0 12 0.0000 4 180 1830 2835 8775 edgelengths (e0, e1, e2)\001
+-6
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 2475 1350 3375 1350 3375 4050 2475 4050 2475 1350
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2925 1350 2925 4050
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 1.00 60.00 120.00
+	 225 2700 450 2475
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 1.00 60.00 120.00
+	 2250 2700 2475 2475
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 1.00 60.00 120.00
+	 225 6120 450 5895
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1800 5400 1800 8100
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 450 5400 1350 5400 1350 8100 450 8100 450 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 900 5400 900 8100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1350 5400 1800 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1350 8100 1800 8100
+3 0 0 1 0 7 50 -1 -1 0.000 0 0 0 4
+	 675 5625 225 5400 0 2700 450 2475
+	 0.000 1.000 1.000 0.000
+3 0 0 1 0 7 50 -1 -1 0.000 0 0 0 4
+	 4095 5760 2205 4275 1980 2698 2475 2473
+	 0.000 1.000 1.000 0.000
+3 0 0 1 0 7 50 -1 -1 0.000 0 0 0 4
+	 4978 7872 4230 8415 3150 8370 765 8415
+	 0.000 1.000 1.000 0.000
+3 0 0 1 0 7 50 -1 -1 0.000 0 0 0 4
+	 785 8405 135 8460 0 6120 450 5940
+	 0.000 1.000 1.000 0.000
+4 0 0 50 -1 18 12 0.0000 4 180 1950 2475 675 class Vectors(Points)\001
+4 0 0 50 -1 0 12 0.0000 4 180 1350 2475 1125 coordinates (x, y)\001
+4 0 0 50 -1 18 12 0.0000 4 180 1335 450 4725 class Triangles\001
+4 0 0 50 -1 0 12 0.0000 4 180 1530 450 5175 vertices (v0, v1, v2)\001
+4 0 0 50 -1 0 12 0.0000 4 180 1515 3915 5175 normals (n0, n1, n2)\001
+4 0 0 50 -1 0 12 0.0000 4 180 1650 5940 5175 neighbours (t0, t1, t2)\001
+4 0 0 50 -1 0 12 0.0000 4 180 2070 7965 5175 neighbour_faces (f0, f1, f2)\001
Index: /inundation/ga/storm_surge/pyvolution/documentation/mesh_example.fig
===================================================================
--- /inundation/ga/storm_surge/pyvolution/documentation/mesh_example.fig	(revision 626)
+++ /inundation/ga/storm_surge/pyvolution/documentation/mesh_example.fig	(revision 626)
@@ -0,0 +1,55 @@
+#FIG 3.2
+Landscape
+Center
+Metric
+A4      
+100.00
+Single
+-2
+1200 2
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 4
+	 3600 4950 5400 3150 6750 5400 3600 4950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 3600 4950 2700 2700 5400 3150
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 2700 2700 1800 4050 3600 4950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 1800 4050 1350 5400 3600 4950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 1350 5400 3600 7200 3600 4950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3600 7200 6750 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 3600 7200 7650 7200 6750 5400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 6750 5400 8550 4950 7650 7200
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 6750 5400 8100 3600 8550 4950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5400 3150 8100 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 5400 3150 7200 1800 8100 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 5400 3150 4500 900 7200 1800
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2700 2700 4500 900
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 0 0 4
+	 3600 4950 5400 3150 6750 5400 3600 4950
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 4
+	 7200 1800 7470 1575 8460 3510 8100 3600
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 8460 3510 8910 4950 8550 4950
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 8910 4950 7830 7515 7650 7200
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 7830 7515 3105 7470 3600 7200
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 3105 7470 900 5535 1350 5400
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 900 5535 1440 3915 1755 4050
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 1440 3915 2430 2430 2700 2700
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 3
+	 2475 2430 4365 495 4500 900
+2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
+	 4365 495 7470 1575
Index: /inundation/ga/storm_surge/pyvolution/documentation/triangle.fig
===================================================================
--- /inundation/ga/storm_surge/pyvolution/documentation/triangle.fig	(revision 626)
+++ /inundation/ga/storm_surge/pyvolution/documentation/triangle.fig	(revision 626)
@@ -0,0 +1,44 @@
+#FIG 3.2
+Landscape
+Center
+Metric
+A4      
+100.00
+Single
+-2
+1200 2
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 900 3600 90 90 900 3600 990 3600
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4500 3600 90 90 4500 3600 4590 3600
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 900 900 90 90 900 900 990 900
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 0 0 4
+	 900 900 900 3600 4500 3600 900 900
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 0 0 4
+	 4500 8775 4500 6075 900 6075 4500 8775
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 3.00 60.00 120.00
+	 2475 3600 2475 4455
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 3.00 60.00 120.00
+	 900 2250 45 2250
+2 1 0 3 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	2 1 3.00 60.00 120.00
+	 2565 2115 3170 1510
+4 0 0 50 -1 0 12 0.0000 4 135 615 540 720 vertex 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 615 90 3690 vertex 0\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 3420 2700 face 0\001
+4 0 0 50 -1 0 12 0.0000 4 135 615 4770 3600 vertex 1\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 225 1485 face 1\001
+4 0 0 50 -1 0 12 0.0000 4 135 645 2610 4095 normal 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 645 180 2565 normal 1\001
+4 0 0 50 -1 0 12 0.0000 4 135 645 2970 1980 normal 0\001
+4 0 0 50 -1 0 12 0.0000 4 135 510 1620 2565 id = 17\001
+4 0 0 50 -1 0 12 0.0000 4 135 510 3195 7110 id = 13\001
+4 0 0 50 -1 0 12 0.0000 4 180 1200 1620 3330 neighbour2 = 13\001
+4 0 0 50 -1 0 12 0.0000 4 180 1620 1620 3555 neighbour_faces2 = 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 1170 3870 face 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 1395 5940 face 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 615 4500 6030 vertex 0\001
+4 0 0 50 -1 0 12 0.0000 4 135 615 270 6030 vertex 1\001
+4 0 0 50 -1 0 12 0.0000 4 135 615 4185 9045 vertex 2\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 1350 7110 face 0\001
+4 0 0 50 -1 0 12 0.0000 4 135 465 4590 7515 face 1\001